%%%%%%%%%%%%% IF %%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newif \ifhidecomment
\hidecommenttrue
%\hidecommentfalse % comment to hide comments


\newcommand\RT[1]{\ifhidecomment{}\else{\textcolor{blue}{RT: #1}}\fi}
\newcommand\RG[1]{\ifhidecomment{}\else{\textcolor{cyan}{RG: #1}}\fi}
\newcommand\AT[1]{\ifhidecomment{}\else{\textcolor{red}{AT: #1}}\fi}
\newcommand\SM[1]{\ifhidecomment{}\else{\textcolor{magenta}{SM: #1}}\fi}
\newcommand\RH[1]{\ifhidecomment{}\else{\textcolor{orange}{RH: #1}}\fi}



\newif \ifshowauthor
\showauthortrue
\showauthorfalse


\newtheorem{remark}{Remark}
\newtheorem{example}{Example}
\newtheorem{definition}{Definition}
%\newtheorem{assumption}[remark]{Assumption}
\newtheorem{lemma}[remark]{Lemma}
\newtheorem{theorem}[remark]{Theorem}
\newtheorem{proposition}[remark]{Proposition}
\newtheorem{corollary}[remark]{Corollary}
%\newtheorem{conjecture}[remark]{Conjecture}
%\newtheorem{observation}{Observation}

%%%%%%%%%%%%%%% FOR COMMENTS %%%%%%%%%%%%%%%%%%


% Allows for printing code in a codey font
\usepackage{listings}

% Allow bulk comment (eventually obsolete)
\usepackage{comment}

% Math function and fonts
\usepackage{amsmath}
\usepackage{amsfonts}

% mathscr font, super pretty
\usepackage{mathrsfs}

% Used by some diagrams
\usepackage{tikz, xstring, calc, pgfmath}

% Some MSR rules and tables (probably will become obsolete)
\usepackage{multirow}

% Allows ifthenelse commands
\usepackage{ifthen}



\usepackage{url}
% Allows a funny zero

\usepackage{xspace}

\usepackage{subcaption} 

\usepackage{upgreek}

\DeclareMathOperator*{\argmax}{arg\,max}

% resizebox creates a parbox with variable width depending on the length
% of the content. It looks very impressive, but I stole it from stackexchange
\newlength{\minwidth}
\newcommand{\rezizebox}[1]{
\setlength{\minwidth}{\widthof{
\begin{tabular}{@{}l@{}}
#1
\end{tabular}
}}
\parbox{\minwidth}{#1}} 


\mathchardef\mhyphen="2D

\usepackage{pifont}

\newcommand{\cmark}{\ding{51}}%
\newcommand{\xmark}{\ding{55}}%



\newcommand{\suptrace}{\sqsupseteq}
\newcommand{\subtrace}{\sqsubseteq}

\newcommand{\traces}[1]{\ensuremath{\operatorname{traces}(#1)}}

%\newcommand{\tracesattacker}[2]{\tracesof{#1}}
\newcommand{\tracesattacker}[2]{[\hspace{-0.05cm}[#1]\hspace{-0.05cm}]_{#2}}

\newcommand{\ruleSet}{\ensuremath{R}}
\newcommand{\stateSet}{\ensuremath{\mathit{State}}}
\newcommand{\reachStateSet}[1]{\ensuremath{\mathit{State}_{#1}}}
\newcommand{\advRules}{\ensuremath{\mathcal{A}}}
\newcommand{\reachable}[1]{\mapsto_{#1}^{*}}

\newcommand{\emptytrace}{\epsilon}
\newcommand{\trace}{\tau}
\newcommand{\traceproj}{\bar{\tau}}
\newcommand{\traceOrder}{<_{\trace}}
\newcommand{\iniState}{\ensuremath{\astate_{0}}}
\newcommand{\astate}{s}

\newcommand{\stateupdate}[2]{#1[#2]}

\newcommand{\msl}{\{\hspace*{-0.1cm}|}
\newcommand{\msr}{|\hspace*{-0.1cm}\}}

\newcommand{\eCommPartner}[2]{\ensuremath{E(#1, #2, \text{CommPartner})}}
\newcommand{\eCorrupt}[1]{\ensuremath{E(#1, \text{Corrupted})}}

% Reachpred and strongly reachable pred
\newcommand{\reachPred}{\rightsquigarrow}
\newcommand{\strongReachPred}{\leadsto^\ast}

% Make xor more xor-y
\newcommand{\xor}{\oplus}

% "multiset-less-than"
\newcommand{\mlt}{\ensuremath{<_\tau}}
\newcommand{\mset}{\symbol{`\\}}

% 'type'
\newcommand{\type}[1]{\ensuremath\mathsf{#1}}
%\newcommand{\type}[1]{\ensuremath\mathtt{#1}}

\newcommand{\atype}{\ensuremath{\type{s}}}
\newcommand{\typeOrder}{<}
\newcommand{\msgType}{\ensuremath{\type{msg}}}
\newcommand{\keyType}{\ensuremath{\type{key}}}
\newcommand{\nonceType}{\ensuremath{\type{nonce}}}
\newcommand{\constantType}{\ensuremath{\type{constant}}}
\newcommand{\agentType}{\ensuremath{\type{agent}}}

\newcommand{\agentNonceType}[1]{\ensuremath{\type{nonce}_{#1}}}

\newcommand{\aterm}{\ensuremath{t}}
\newcommand{\avar}{\ensuremath{v}}
\newcommand{\anagent}{\ensuremath{A}}

\newcommand{\typeSpec}[2]{\ensuremath{#1 \colon #2}}

\newcommand{\proxrel}{\ensuremath{\approx_{\ell}}}
\newcommand{\proxfunc}[1]{\ensuremath{\textsf{prox}(#1)}}


\newcommand{\funcName}[1]{\ensuremath{\textsf{#1}}}
\newcommand{\afunc}{\funcName{f}}
\newcommand{\ruleName}[1]{\ensuremath{\textsc{#1}}}


\newcommand{\xorFunc}{\funcName{xor}}
\newcommand{\sencFunc}{\funcName{senc}}
\newcommand{\sdecFunc}{\funcName{sdec}}
\newcommand{\aencFunc}{\funcName{aenc}}
\newcommand{\adecFunc}{\funcName{adec}}
\newcommand{\signFunc}{\funcName{sign}}
\newcommand{\pkFunc}{\funcName{pk}}
\newcommand{\skFunc}{\funcName{sk}}
\newcommand{\pairFunc}{\funcName{pair}}
\newcommand{\keyFunc}{\funcName{k}}
\newcommand{\coverFunc}{\funcName{cover}}
\newcommand{\hashFunc}{\funcName{h}}


\newcommand{\timedChall}{\mathrm{timed \mhyphen chall}}
\newcommand{\timedResp}{\mathrm{timed \mhyphen resp}}

\newcommand{\timedChallSend}{\mathrm{timed \mhyphen chall \mhyphen send}}
\newcommand{\timedChallRecv}{\mathrm{timed \mhyphen chall \mhyphen recv}}

\newcommand{\timedChallRespSend}{\mathrm{timed \mhyphen chall \mhyphen resp \mhyphen send}}
\newcommand{\timedChallRespRecv}{\mathrm{timed \mhyphen chall \mhyphen resp \mhyphen recv}}

%\newcommand{\keyFunc}{\funcName{k}}

\newcommand{\encSymbol}{\ensuremath{\encFunc(\keyType, \msgType) \rightarrow 
\msgType}}
\newcommand{\decSymbol}{\ensuremath{\decFunc(\keyType, \msgType) \rightarrow 
\msgType}}
\newcommand{\hashSymbol}{\ensuremath{\hashFunc(\msgType) \rightarrow \msgType}}
\newcommand{\pairSymbol}{\ensuremath{\pairFunc(\msgType, \msgType) \rightarrow 
\msgType}}
\newcommand{\keySymbol}{\ensuremath{\keyFunc(\keyType, \keyType)}}

% % % % % % % % % % % % % Rolando's commands % % % % % % % % % % % % % % %

\newcommand{\varSet}{\ensuremath{\mathbb{V}}}
\newcommand{\termSet}{\ensuremath{\mathbb{T}}}
\newcommand{\factSet}{\ensuremath{\mathbb{F}}}
\newcommand{\multiSetSet}{\ensuremath{\mathbb{M}}}

\newcommand{\aSubFunc}{\sigma}
\newcommand{\aMultiSet}{\ensuremath{M}}
\newcommand{\aRule}{\ensuremath{r}}

\newcommand{\ruleApp}[3]{#1 \xrightarrow{#2} #3}
\newcommand{\ruleTrace}[2]{#1_1 \xrightarrow{#2_1} #1_2 \xrightarrow{#2_2} 
\cdots \xrightarrow{#2_{n-1}} #1_n}
\newcommand{\transition}{\rightarrow}


\newcommand{\rulesApp}[3]{#1 \xrightarrow{#2}\mathrel{\vphantom{\to}^*} #3}
\newcommand{\subApp}[2]{\ensuremath{#1 #2}}

%\newcommand{\freshPred}{\ensuremath{Fr}}
\newcommand{\freshpred}{\ensuremath{fresh}}

\newcommand{\networkPred}{\ensuremath{Net}}
\newcommand{\knowPred}{\ensuremath{Kn}}

\newcommand{\freshSymbol}{\freshPred(\nonceType)}
\newcommand{\networkSymbol}{\networkPred(\msgType)}
\newcommand{\knowSymbol}{\knowPred(\msgType)}

\newcommand{\signature}{\Sigma}

\newcommand{\freshRule}{\ruleName{Fresh}}

\newcommand{\rulehead}{\ensuremath{head}}

\newcommand{\deducRuleSet}{\ensuremath{D}}
\newcommand{\advRuleSet}{\ensuremath{A}}
\newcommand{\protRuleSet}{\ensuremath{R}}

\newcommand{\protTuple}{(\deducRuleSet, \advRuleSet, 
\protRuleSet,\iniState)}

\newcommand{\headingfourthlevel}[1]{
\ifCLASSOPTIONcompsoc
\emph{#1:}
\else
\paragraph*{#1}
\fi}

%%%%%%%%%%% SETS AND CONSTANTS %%%%%%%%%%%
\newcommand{\msgsetground}{\z{Msg_g}}

\newcommand{\grammarequal}{::=}
\newcommand{\msgset}{\z{Msg}}
%\newcommand{\constset}{Const}
%\newcommand{\nonceset}{Nonce}
%\newcommand{\agentset}{Agent}
%\newcommand{\agentknow}{Know}
%\newcommand{\honestset}{Honest}
%\newcommand{\dishonestset}{Dishonest}
\newcommand{\symkeyset}{\z{SymKey}}
\newcommand{\asymkeyset}{\z{AsymKey}}

\newcommand{\constset}{\z{Const}}
\newcommand{\indexset}{\z{Index}}
\newcommand{\nonceset}{\z{Nonce}}
\newcommand{\agentset}{\z{Agent}}
\newcommand{\agentknow}{\z{Know}}
\newcommand{\honestset}{\z{Honest}}
\newcommand{\dishonestset}{\z{Dishonest}}


\newcommand{\funset}{\z{Func}}
%\newcommand{\privfunset}{\{ \seckey{}, \shakey{}{}, \pubkey{}\}}
\newcommand{\privfunset}{\{ \seckey{}, \keyFunc\}}
%\newcommand{\privfunset}{\{ \shakey{}{}\}}

%%%%%%%%%%%%%% INSTANCES %%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\anonce}{n}

\newcommand{\nonce}[1]{N_{#1}}

\newcommand{\nonceP}{\nonce{\prover}}
\newcommand{\nonceV}{\nonce{\verifier}}

\newcommand{\anevent}{e}

\newcommand{\agentdishonest}{c}
\newcommand{\agenta}{a}
\newcommand{\agentb}{b}

\newcommand{\agentA}{A}
\newcommand{\agentB}{B}

\newcommand{\agentc}{c}
\newcommand{\verifier}{v}
\newcommand{\prover}{p}
\newcommand{\roleverifier}{V}
\newcommand{\roleprover}{P}
%\newcommand{\verifier}{V}
%\newcommand{\prover}{P}

\newcommand{\protocol}{\mathcal{P}}

%\newcommand{\satisfies}{\vdash}

%%%%%%%%%% OPERATORS, PREDICATES AND FUNCTIONS %%%%%%%%%

\newcommand{\proxseckey}[2]{sk_{#1}\ifthenelse{\equal{#1}{\empty}}{}{(#2)}}
\newcommand{\proxpubkey}[2]{pk_{#1}\ifthenelse{\equal{#1}{\empty}}{}{(#2)}}

\newcommand{\seckey}[1]{\skFunc\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
\newcommand{\pubkey}[1]{\pkFunc\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
\newcommand{\shakey}[2]{k\ifthenelse{\equal{#1}{\empty}}{}{(#1,#2)}}
%\newcommand{\shakey}[2]{key\ifthenelse{\equal{#1}{\empty}}{}{(#1,#2)}}
\newcommand{\enc}[2]{\left\lbrace #1 \right\rbrace _ {#2}}
\newcommand{\invkey}[1]{{#1}^{-1}}

%\newcommand{\pair}[2]{(#1,#2)}
\newcommand{\pair}[2]{\left\langle #1,#2 \right\rangle }

\newcommand{\concat}{\cdot}

\newcommand{\initknowledge}[1]{init(#1)}
\newcommand{\content}[1]{cont\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
\newcommand{\actor}[1]{\mathit{actor}\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
\newcommand{\actors}[1]{\mathit{actors}\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
%\newcommand{\sent}[1]{sent\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}
\newcommand{\size}[1]{size\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}

%%%%%%%%%% MESSAGES %%%%%%%%%%%%%%
\newcommand{\auxmsgm}{l}

\newcommand{\msgm}{m}
\newcommand{\msgM}{M}

\newcommand{\challenge}{C}
\newcommand{\response}{r}
\newcommand{\complmnt}{z}

%%%%%%%%%%%%%% MESSAGES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\variables}{\mathcal{V}}
\newcommand{\constants}{\mathcal{C}}
\newcommand{\term}{\mathcal{T}_{\signature}(\variables, \constants)}
\newcommand{\functionset}{\signature_{\mathit{func}}}
\newcommand{\freshset}{\signature_{\mathit{fresh}}}
\newcommand{\publicset}{\signature_{\mathit{pub}}}


%%%%%%%%%%%%%%%% RULES %%%%%%%%%%%%%%%%%%%
% 1st argument: premise (joint by endlines if multiple lines)
% 2nd argument: conclusion (joint by endlines if multiple lines)
% 3rd argument: rule name
% Comments: 
%		1. In-line premise or conslusion must be manually separated by 
%%%			\spaceinrule
%		2. Rules must be placed within math enviroments.
\newcommand{\makerule}[3]{\frac{\begin{array}{@{}c@{}}#1\end{array}}
			{\begin{array}{@{}c@{}}#2\end{array}}~\rulelabelfont{#3}}

\newcommand{\spaceinrule}{\hspace{3ex}}
\newcommand{\spaceoutrule}{\hspace{5ex}}
\newcommand{\rulelabelfont}[1]{\texttt{#1}}

%%%%%%%%%%%%%%%% MISCELLANEOUS %%%%%%%%%%%%%%%
%\newcommand{\substitution}[2]{#1 \mapsto #2}
\newcommand{\subterm}{\sqsubseteq}
%\newcommand{\subtrace}{\sqsubseteq}

%%%%%%%%%%%%%%% OTHERS %%%%%%%%%%%%%%%%%%%%
\newcommand{\integersfromto}[2]{\{#1,\dots,#2\}}
\newcommand{\mincorrupt}[1]{\ensuremath{#1^{\star}}}

\newcommand{\predfont}[1]{\mathit{#1}}
\newcommand{\dbsec}{\predfont{dbsec}}
\newcommand{\alive}{\predfont{aliveness}}
\newcommand{\dbhonest}{\predfont{db}}
\newcommand{\erasure}{\predfont{erasure}}
\newcommand{\timedclaim}{\secprop_{\predfont{timed}}}
\newcommand{\casualclaim}{\secprop_{\predfont{casual}}}

\newcommand{\agree}{\predfont{agree}}
\newcommand{\skey}{\predfont{skey}}

%\newcommand{\erasure}{\predfont{erase}}
\newcommand{\auth}{\predfont{auth}}
\newcommand{\prox}{\predfont{close}}
\newcommand{\secrecy}{\predfont{secrecy}}
\newcommand{\asecrecy}{\predfont{anon\_secrecy}}
\newcommand{\aliveness}{\predfont{aliveness}}
\newcommand{\aaliveness}{\predfont{anon\_aliveness}}
\newcommand{\noninjectiveagreement}{\predfont{non\_injective\_agreement}}
\newcommand{\anoninjectiveagreement}{\predfont{anon\_non\_injective\_agreement}}
\newcommand{\weakagreement}{\predfont{weak\_agreement}}
\newcommand{\aweakagreement}{\predfont{anon\_weak\_agreement}}

\newcommand{\true}{\mathsf{True}}
\newcommand{\false}{\mathsf{False}}

\newcommand{\secpropprime}{sec}
\newcommand{\secprop}{\psi}
\newcommand{\validpred}[1]{{#1}^{v}}
%\newcommand{\correctpred}[1]{{#1}^{c}}
%\newcommand{\validpred}[1]{valid_{#1}}
%\newcommand{\correctpred}[1]{correct_{#1}}
\newcommand{\correctpred}{\predicatestyle{correct}}
\newcommand{\trustpred}{\predicatestyle{trust}}
\newcommand{\honestagentspred}{\predicatestyle{honest\_agents}}
\newcommand{\knownattackerpred}{\predicatestyle{known\_attacker}}
\newcommand{\setknownlocalattackerpred}{\predicatestyle{dishonest\_agents}}
%\newcommand{\setknownlocalattackerpred}{\predicatestyle{skla}}
\newcommand{\validclaim}{\predicatestyle{correct\_time}}

\newcommand{\predicatestyle}[1]{\mathsf{#1}}

%\newcommand{\insecprop}{\bar{\secprop}}
\newcommand{\insecprop}{\validpred{\secprop}}


%\newcommand{\secprop}{\pi}
\newcommand{\powerset}[1]{\mathbb{P}(#1)}
\newcommand{\realset}{\mathbb{R}}
%\newcommand{\realsetpos}{\realset}
\newcommand{\realsetpos}{\mathbb{R}^+}


\newcommand{\templaterule}[2]{\ensuremath{#1 \rightarrow \left[ #2 
\right]}}

\newcommand{\signalrule}{\ensuremath{\mathsf{Signal}}}

\newcommand{\equalrule}{\ensuremath{\mathsf{Equal}}}
\newcommand{\sendrule}{\ensuremath{\mathsf{Send}}}
\newcommand{\recvrule}{\ensuremath{\mathsf{Recv}_{\distfunc}}}
\newcommand{\claimrule}{\ensuremath{\mathsf{Claim}}}
\newcommand{\timerule}{\ensuremath{\mathsf{Clock}}}
\newcommand{\createrule}{\ensuremath{\mathsf{Create_{\protocol}}}}

\newcommand{\sendrulet}{\ensuremath{\mathsf{Send_\pi}}}
\newcommand{\recvrulet}{\ensuremath{\mathsf{Recv_\pi}}}
\newcommand{\claimrulet}{\ensuremath{\mathsf{Claim_\pi}}}
\newcommand{\timerulet}{\ensuremath{\mathsf{Clock_\pi}}}
\newcommand{\createrulet}{\ensuremath{\mathsf{Create_{\protocol\pi}}}}
\newcommand{\signalrulet}{\ensuremath{\mathsf{Signal_\pi}}}
\newcommand{\equalrulet}{\ensuremath{\mathsf{Equal_\pi}}}


\newcommand{\networkdistruleext}{\ensuremath{\mathsf{NetExt}}}

\newcommand{\networkdistrule}{\ensuremath{\mathsf{Recv}}}
%\newcommand{\networkdistrule}{\ensuremath{\mathsf{Net}}}
%\newcommand{\networkdistrule}{\ensuremath{\mathsf{Net}_\advdist}}
\newcommand{\networkrule}{\ensuremath{\mathsf{Net}}}
\newcommand{\adversaryrule}{\ensuremath{\mathsf{Adv}}}
\newcommand{\distadvrule}{\ensuremath{\mathsf{Adv}_{\advdist}}}

\newcommand{\correctchallresprule}{\ensuremath{\mathsf{CorrectTiming}}}
\newcommand{\earlychallresprule}{\ensuremath{\mathsf{EarlyTiming}}}

\newcommand\astartclock{\text{start-clock}\xspace}
\newcommand\aendclock{\text{end-clock}\xspace}


\newcommand{\infer}{\vdash}
\newcommand{\emptyseq}{\epsilon}
\newcommand{\related}[3]{#1\concat #2 \in #3}

%\newcommand{\no}{\ding{53}}
%\newcommand{\yes}{\ding{51}}
\newcommand{\no}{No}
\newcommand{\yes}{Yes}

%\newcommand{\protoset}{\z{Proto}}
\newcommand{\secpropset}{\z{Sec}}
\newcommand{\setofanb}{{\{\agenta,\agentb\}}}
\newcommand{\seqofnevents}{e_1\cdots e_n}
%\newcommand{\claimtraces}{\mathcal{C}}

\newcommand{\satisfies}{\triangleright}
\newcommand{\notsatisfies}{\ntriangleright}
%\newcommand{\notsatisfies}{\not \satisfies}

\newcommand{\csatisfies}{\satisfies_{r}^{\pi}}
\newcommand{\rsatisfies}{\satisfies_{r}^{\advdist}}
\newcommand{\rnotsatisfies}{\notsatisfies}
%\newcommand{\rnotsatisfies}{\not \rsatisfies}

\newcommand{\session}[1]{\Gamma\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}

\newcommand{\myforall}[2]{\forall_{{#1}}{\;#2}}
\newcommand{\myexists}[2]{\exists_{{#1}}{\;#2}}
\newcommand{\mynexists}[2]{\nexists_{{#1}}{\;#2}}
\newcommand{\subknoweq}{\models}
\newcommand{\wellformedtraces}{\z{W}}

%\newcommand{\verify}[1]{\pi\ifthenelse{\equal{#1}{\empty}}{}{(#1)}}

%%%% Tamarin-related stuff %%%%
\newcommand{\fact}[2]{#1 (#2)}
\newcommand{\factName}[1]{#1}
%\newcommand{\ruleName}[1]{#1}

\newcommand{\z}[1]{\mathsf{#1}}

\newcommand{\eventsymbolset}{\ensuremath{\mathcal{E}}}
\newcommand{\eventset}{\z{Ev}}
\newcommand{\signaleventset}{\z{SignalEvent}}

\newcommand{\eventsetground}{\z{Ev_g}}

\newcommand{\timemeas}[2]{\mathrm{clock}_{#1}(#2)}  

\newcommand{\sendeventname}{\mathrm{send}}  
\newcommand{\recveventname}{\mathrm{recv}}  
\newcommand{\claimeventname}{\mathrm{claim}}  
\newcommand{\clockeventname}{\mathrm{clock}}  
\newcommand{\equaleventname}{\mathrm{equal}}  

\newcommand{\send}[2]{\sendeventname_{#1}(#2)}  
\newcommand{\recv}[2]{\mathrm{recv}_{#1}(#2)}
\newcommand{\createevent}[2]{\mathrm{create}_{#1}(#2)}
\newcommand{\clockevent}[2]{\mathrm{\clockeventname}_{#1}(#2)}
\newcommand{\equalevent}[2]{\mathrm{\equaleventname}_{#1}(#2)}
%\newcommand{\clockevent}[2]{\mathrm{\Delta}_{#1}(#2)}


\newcommand{\timeron}[2]{\mathrm{end\mhyphen clock}_{#1}(#2)}

\newcommand{\timeroff}[2]{\mathrm{start\mhyphen clock}_{#1}(#2)}



\newcommand{\sendset}{\z{Send}}
\newcommand{\recvset}{\z{Recv}}

\newcommand{\claimset}{\z{Claim}}
\newcommand{\claiminst}{\claim{\agenta}{\secprop,\msgm}}
\newcommand{\claiminstdb}{\claim{\verifier}{\dbhonest,\prover, 
\challenge,\response}}

\newcommand{\sendfast}[2]{\mathrm{send\mhyphen fast}_{#1}(#2)}  


\newcommand{\claim}[2]{\mathrm{claim}_{#1}(#2)}

\newcommand{\claimtimed}[3]{\mathrm{claim}_{#1}(#2)\Big[#3\Big]}
%\newcommand{\claimtimed}[3]{\mathrm{claim}_{#1}(#2)\left[#3\right]}



%%%%%%%%%%%%%%% TRACES %%%%%%%%%%%%%%%%%
%\newcommand{\tracesof}[2]{\llbracket #1 \rrbracket 
%\ifthenelse{\equal{#2}{\empty}}{}{_{#2}}}

%\newcommand{\tracesof}[1]{Tr_{\advdist}(#1)}

\newcommand{\paramtracesof}[2]{[\hspace{-0.05cm}[#1]\hspace{-0.05cm}]_{#2}}

\newcommand{\disttracesof}[1]{\paramtracesof{#1}{\advdist}}

\newcommand{\tracesof}[1]{[\hspace{-0.05cm}[#1]\hspace{-0.05cm}]}

\newcommand{\traceset}{\ensuremath{\mathcal{T}}}

%%%%%%%%%%%%%% Function symbols %%%%%%%%%%%%%%%%%%%%%%


\newcommand{\advdist}{\delta}

%\newcommand{\dbattacker}{distant attacker}
%\newcommand{\Dbattacker}{Distant attacker}

%\newcommand{\dbattackers}{non-local attackers}
%\newcommand{\Dbattackers}{Non-local attackers}
%\newcommand{\dbattacker}{non-local attacker}
%\newcommand{\Dbattacker}{Non-local attacker}
%
%\newcommand{\dbattacks}{non-local attacks}
%\newcommand{\Dbattacks}{Non-local attacks}
%\newcommand{\dbattack}{non-local attack}
%\newcommand{\Dbattack}{Non-local attack}

\newcommand{\dbattackers}{remote attackers}
\newcommand{\Dbattackers}{Remote attackers}
\newcommand{\dbattacker}{remote attacker}
\newcommand{\Dbattacker}{Remote attacker}

\newcommand{\dbattacks}{remote attacks}
\newcommand{\Dbattacks}{Remote attacks}
\newcommand{\dbattack}{remote attack}
\newcommand{\Dbattack}{Remote attack}



%%%%%%%%%%%%%%%%% Automata-based representation %%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\tuple}{(\insym, \outsym, \states, \initialstate, \transfunct, 
\outfunct)}
\newcommand{\tuplei}{(\insym_i, \outsym_i, \states_i, \initialstate^i, 
\transfunct_i, 
\outfunct_i)}
\newcommand{\tuplej}{(\insym_j, \outsym_j, \states_j, \initialstate^j, 
\transfunct_j, 
\outfunct_j)}
\newcommand{\tupleprime}{(\insym', \outsym', \states', {\initialstate}', 
\transfunct', \outfunct')}

\newcommand{\emptystring}{\ensuremath{\varepsilon}}

\newcommand{\statefunction}{\hat{\transfunct}}
\newcommand{\outputfunction}{\hat{\outfunct}}

\newcommand{\insym}{\Sigma}
\newcommand{\outsym}{\Gamma}

\newcommand{\states}{Q}
\newcommand{\initialstate}{q_0}
\newcommand{\transfunct}{\delta}
\newcommand{\outfunct}{\ell}

% \newcommand{\condition}[1]{\mbox{\emph{#1 }}}
\newcommand{\compfunc}{generalized transition function}
\newcommand{\Compfunc}{Generalized transition function}

\newcommand{\tupleii}[1]{(\insym, \outsym, \states, \initialstate,\transfunct, 
	\outfunct_{#1})}

%\newcommand{\tuplei}[1]{(\insym,\outsym,\states_{#1}, \initialstate_{#1}, 	
%\transfunct_{#1}, \outfunct_{#1})}
%\newcommand{\tupleprime}{(\insym,\outsym,\states', \initialstate', 
%\transfunct', \outfunct')}
%\newcommand{\tupleii}[1]{(\insym,\outsym,\states, \initialstate, \transfunct, 	
%\outfunct_{#1})}
\newcommand{\tuplepp}{(\insym,\outsym,\states, \initialstate, 
	\transfunct, \outfunct')}

\newcommand{\seq}[3]{\ensuremath{{#1}_{#2}\cdots{#1}_{#3}}}
\newcommand{\setIntegers}[2]{\ensuremath{\{#1,\dots,#2\}}}

\newcommand{\eqLongSpace}{\quad \quad}

\newcommand{\tupleasim}{(\insym,\outsym,\states, \initialstate, \transfunct, 
\outfunct')}
\newcommand{\tuplepsim}{(\insym,\outsym,\states, \initialstate, \transfunct', 
\outfunct')}
\newcommand{\universe}{\ensuremath{\mathbf{U}_{\insym,\outsym}}}

\newcommand{\ldb}{lookup-based}
\newcommand{\Ldb}{Lookup-based}
%\newcommand{\ldb}{PDB}
\newcommand\dba{\ldb{} protocol}
\newcommand\Dba{\Ldb{} protocol}
%\newcommand\dbas{lookup-based DB protocols}
\newcommand\dbainst{\ensuremath{P}}
%\newcommand\Dba{Lookup-based DB protocol}
%\newcommand\Dba{\dba{}}
%\newcommand\udba{Unif-DBA}
\newcommand\automaton{DFA}
\newcommand\automatoninst{A}
\newcommand\labelautomaton{state-labeled DFA}


\newcommand{\mylist}[3]{\ensuremath{{#1}_{#2},\dots,{#1}_{#3}}}
\newcommand{\B}{\ensuremath{\mathcal{B}}_n}
%\newcommand{\AIn}[2]{\ensuremath{\Omega(#1,#2)}}
%\newcommand{\AIn}[2]{\ensuremath{\Omega(#2)}}
\newcommand{\AInExt}[3]{\ensuremath{\Omega_{#1}^{#2}(#3)}}
\newcommand{\AIn}[2]{\ensuremath{\Omega_{#1}(#2)}}
\newcommand{\stt}{z}
\newcommand{\AIns}[2]{\ensuremath{\Omega^\stt_{#1}(#2)}}%only for 
%theorem~\ref{th:randomLabeledIsBetter}

\newcommand{\pseudofunc}{f}

\newcommand{\freshfunc}{\ensuremath{\operatorname{fresh}}}
\newcommand{\maxfunc}{\ensuremath{\operatorname{max\_time}}}
%\newcommand{\maxfunc}{\ensuremath{\operatorname{max}}}
%\newcommand{\varfunc}{\ensuremath{\operatorname{var}}}

\newcommand{\distfunc}{\ensuremath{\operatorname{d}}}
\newcommand{\symbolzero}{\ensuremath{\slashzero}}

\newcommand{\speedcom}{\ensuremath{\mathsf{c}}}

\newcommand{\projection}{\pi}
\newcommand{\projfun}[1]{#1_{\pi}}

\newcommand{\depth}{d}

\newcommand{\rounds}{n}

\newcommand{\repetitions}{x}

\newcommand{\treeuniverse}{\ensuremath{\mathbf{T}_{\depth}}}
\newcommand{\autouniverse}{\ensuremath{\mathbf{A}}}


\newcommand{\treeauto}{\ensuremath{{T}^{\outfunct}_{\depth}}}

\newcommand{\protocolIni}{\ensuremath{\protocol_{ini}}}

\newcommand{\treeprotocol}{\ensuremath\mathcal{T}}

\newcommand{\fraudprover}{\ensuremath{c}}
%\newcommand{\fraudprover}{\ensuremath{\mathbf{C}}}
\newcommand{\multisetTerm}[2]{\ensuremath{\operatorname{#1}(#2)}}

%Later added
\newcommand{\fst}{\mathit{fst}}
\newcommand{\snd}{\mathit{snd}}
\newcommand{\params}{\mathit{params}}
\newcommand{\data}{\mathit{data}}

%%%%%%%%%%% SETS AND CONSTANTS %%%%%%%%%%%
\newcommand{\emptySet}{\emptyset}
\newcommand{\setAssignment}{::=}
\newcommand{\sintMessSet}{\z{Msg}}
\newcommand{\messSet}{\z{Msg}}
\newcommand{\constSet}{\z{Const}}
\newcommand{\atom}{atom}
\newcommand{\nonceSet}{\z{Nonce}}
\newcommand{\pubSet}{\z{Pub}}
\newcommand{\freshSet}{\z{Fresh}}
\newcommand{\tempSet}{\z{Temporal}}
\newcommand{\nonceSetAgent}[1]{\nonceSet_{#1}}
%\newcommand{\agentSet}{\z{Agent}}
\newcommand{\honestAgentSet}{\z{Honest}}
\newcommand{\dishonestAgentSet}{\z{Dishonest}}
\newcommand{\superDishonest}{\z{Reveal}}
\newcommand{\powerSetOf}[1]{\mathcal{P}\left(#1 \right) }
\newcommand{\speedOfLight}{\z{c}}
\newcommand{\functNames}{\mathcal{F}}
\newcommand{\basicFunctionNames}{\mathcal{B}}
\newcommand{\IKset}{\mathit{IK}}

%%%%%%%%%%%%%%%%%%%%% Buitafying notation %%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\tamarin}{\textsc{Tamarin}}
\newcommand{\moveauth}{Move2Auth}
%\newcommand{\moveauth}{\textsc{Move2Auth}}


%\newcommand{\distSepPred}[3]{\ensuremath{separation{#2, #3}(#1)}}
\newcommand{\distSepPred}[3]{\ensuremath{adv\_sep_{\advdist}(#1,#2, 
#3)}}

\newcommand{\distSepPredZero}[3]{\ensuremath{adv\_sep_{0}(#1,#2, 
#3)}}

\newcommand{\advSepPred}[3]{\ensuremath{adv\_sep_{\sim}(#1,#2, 
		#3)}}


\newcommand{\execs}{\mathcal{E}}
\newcommand{\anexec}{\pi}

\newcommand{\commrel}{\rightsquigarrow}
%\newcommand{\commrel}{\prec}
\newcommand{\closerel}{\sim_{\sessionfunc}^{{\trace}}}
\newcommand{\sessionfunc}{f}
\newcommand{\advSep}{\ensuremath{adv\_sep_{\pi}}}

\newcommand{\ordered}{ordered}
\newcommand{\Ordered}{Ordered}

\newcommand{\sortset}{\mathcal{S}}

\newcommand{\sessionset}{\z{Sessions}}

\newcommand{\nearrelation}{\sim}

%%%%%%%%%%%%%%%%%%%%%%% LTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\alphabet}{\ensuremath{\Lambda}}
\newcommand{\myarrow}[1]{\stackrel{#1}{\to}}

\newcommand{\transitions}{\ensuremath{\myarrow{}}}
\newcommand{\multtransitions}{\ensuremath{\stackrel{}{\to}^{*}}}
\newcommand{\startstate}{\ensuremath{s_{0}}}
\newcommand{\startstates}{\ensuremath{s_{0}}}

\newcommand{\finalstate}{\ensuremath{s_{f}}}
\newcommand{\ltstuple}{(\states,\alphabet,\transitions,\startstates)}
\newcommand{\ltstupleWith}[1]{(\states,\alphabet,\transitions,#1)}
\newcommand{\systemtuple}{(\sorts, \funcs,\varsof{\asort}, \truleset)} % tuple 
%for system models
\newcommand{\ltstupleindexed}[1]{\ensuremath{(\states,\alphabet_{#1}, 
		\transitions_{#1}, \startstate)}}
\newcommand{\ltstupleprime}{(\states',\alphabet',\transitions',\startstate')}

\newcommand{\ltstupleinput}[1]{(\states_{#1},\alphabet_{#1},\transitions_{#1},	
\startstate_{#1})}

\newcommand{\ltss}{\ensuremath{\mathit{LTS}}}
\newcommand{\specs}{\ensuremath{P}}
\newcommand{\aspec}{\ensuremath{p}}
\newcommand{\ltsof}{\ensuremath{\ell}}



\newcommand{\alabel}{\ensuremath{\ell}}



\newcommand{\rolevars}{\ensuremath{\mathit{rolevars}}}
\newcommand{\varfunc}{\ensuremath{\mathit{vars}}}
\newcommand{\headfunc}{\ensuremath{\mathit{head}}}


\newcommand{\sigmasession}{\ensuremath{\operatorname{\sigma-session}}}
\newcommand{\smallestsub}{\ensuremath{\operatorname{smallest-sub}}}


%\newcommand{\instsavoid}[2]{\ensuremath{#1 \setminus #2}}
\newcommand{\instsavoid}[2]{\ensuremath{\insts(#1, #2)}}


\newcommand{\freshsetfunc}{\ensuremath{\mathit{nonces}}}
%\newcommand{\freshsetfunc}{\ensuremath{\mathit{freshset}}}

\newcommand{\noncesfun}{\ensuremath{\mathit{nonces}}}
\newcommand{\insts}{\ensuremath{insts}}
\newcommand{\groundterm}{\mathcal{T}_{\signature}(\constants)}
\newcommand{\subs}{\sigma}
\newcommand{\subsuni}{\Gamma}

\newcommand{\domain}{domain}


\newcommand{\runidset}{\z{Id}}

\newcommand{\runs}[1]{runs(#1)}

\newcommand{\stateevents}[1]{\mathit{labels}(#1)}
%\newcommand{\stateevents}[1]{events(#1)}


\newcommand{\astatepair}{(\advknow, \runset)}
\newcommand{\runset}{\astate^{r}}
\newcommand{\advknow}{\astate^{a}}



\newcommand{\rolenameset}{\z{RoleName}}
\newcommand{\arunevent}{e}
%\newcommand{\aroleevent}{E}
\newcommand{\aroleevent}{r}
\newcommand{\arole}{R}
\newcommand{\rolesfunc}{roles}
\newcommand{\rulefunc}{rule\xspace}
\newcommand{\arule}{\rho}
\newcommand{\trans}{transition}
\newcommand{\roleset}{\z{R}}


\newcommand{\runid}{id}

\newcommand{\runfunc}{run-assigment}
\newcommand{\Runfunc}{Run-assigment}

\newcommand{\naturals}{\mathbb{N}}
\newcommand{\positives}{\mathbb{Z}^+}
\newcommand{\agentfunc}{principals}
%\newcommand{\agentfunc}{agents}
\newcommand{\loc}{\ensuremath{\mathit{loc}}}


%%%%%%%%%%%%%%%%%%% LTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\anlts}{\ensuremath{l}} 


%\newcommand\pto{\mathrel{\ooalign{\hfil$\mapstochar$\hfil\cr$\to$\cr}}}
\newcommand\pto{\mathrel{\ooalign{\hfil$\mapstochar\mkern5mu$\hfil\cr$\to$\cr}}}

\makeatletter
\newcommand{\premiselist}[1]{#1\checknextargp}
\newcommand{\checknextargp}{\@ifnextchar\bgroup{\gobblenextargp}{}}
\newcommand{\gobblenextargp}[1]{\quad#1\@ifnextchar\bgroup{\gobblenextargp}{}}

\newcommand{\conclusionlist}[1]{#1\checknextargc}
\newcommand{\checknextargc}{\@ifnextchar\bgroup{\gobblenextargc}{}}
\newcommand{\gobblenextargc}[1]{, #1\@ifnextchar\bgroup{\gobblenextargc}{}}
\makeatother


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Security Properties %%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\castfunc}{\Gamma}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Rules definitions

\newcommand{\rulepreamble}{
\astate \in \states, t \geq \maxfunc(\astate), (\runid, \trace, R, \agenta) 
\in 
\astate,\\
\trace = (t_1, e_1) \cdots (t_{i}, e_{i}), 	\\
e_1 \cdots e_{i} e_{i+1} \in_{s \setminus (\runid, \trace, R, \agenta)} 
\insts(R), \\
}

\newcommand{\rulepreambletimeless}{
\astate \in \states, (\runid, \trace, R, \agenta) 
\in \astate,
\trace = e_1 \cdots e_{i}, 	\\
e_1 \cdots e_{i} e_{i+1} \in \instsavoid{R}{\noncesfun(s \setminus 
(\runid, \trace, R, \agenta))},\\
}

\newcommand{\tautrans}{\uptau}

\newcommand{\timedtracename}{trace}
%\newcommand{\timedtracename}{time-stamped trace}
\newcommand{\tracename}{trace}
\newcommand{\timedtracenames}{traces}
%\newcommand{\timedtracenames}{time-stamped traces}
\newcommand{\tracenames}{traces}

\newcommand{\premise}{\predfont{premise}}
